#!/usr/bin/env ruby -W

# weexb create demo

require_relative 'project'

module WeexBuilder
  class Runner
    def initialize(args)
      @args = args
    end
      
    # create
    # platform add ios/android 
    def exec 
      return usage if @args.length == 0
      
      case @args.first
      when 'create'
        return action_usage(@args.first) unless @args.length == 2
        WeexBuilder::Project.create(@args[1])
      when 'platform'
        return action_usage(@args.first) unless @args.length == 3
        return action_usage(@args.first) unless @args[1] == 'add' && /^(iOS|android)$/i =~ @args[2] 

        WeexBuilder::Project.add_platform(@args[2])
      else 
        usage
      end
    end

    private 

    def action_usage(name)
      case name
      when 'create'
        puts 'Please Use: weexbuilder create YOUR_PROJECTNAME'
      when 'platform'
        puts 'Please Use: weexbuilder platform add iOS/android'
      else 
        usage
      end
    end

    def usage
      puts <<-"..."
Usage:
    
    $ weexbuilder COMMAND [ACTION]

Commands:

    + create    Create a new weex Project
    + platform  

      ...
    end
  end

end